function md_plot_points_both_dists(x,old_x,diff,binlocKNN,countsKNN,binloc,counts,iter,lambda,num_knn)
% Draws plots of the position of the points, the diffusion vectors, the
% histograms of distances and of kNN distances.

%% Drawing Picture

% determine scale of the data
x_min=min(x,[],2);
x_max=max(x,[],2);

% colormap
map=[ [0,0,1];[0,1,0]; [0,0,0]; [1,0,0]; [1,1,0] ; [0,1,1]; [1,0,1] ];
if( rem(iter,1)==0)
    scrsz = get(0,'ScreenSize');
    figure('Position',[1 scrsz(4)/2 scrsz(3)/2.5 scrsz(4)/2.5])

    title(['Lambda=',num2str(lambda)])
    subplot(2,2,1)
    title('Data points');
    hold on
    scatter(x(1,:),x(2,:),'filled');
    colormap(map);
    grid on
    %F(iter)=getframe;
    axis([x_min(1) x_max(1) x_min(2) x_max(2) ]);


    view(2)
    hold off
    colormap(hsv(128));

    subplot(2,2,2)
    title('Diffusion vector field');
    hold on
    quiver(old_x(1,:)',old_x(2,:)',diff(1,:)',diff(2,:)',2);
    grid on
    axis([x_min(1) x_max(1) x_min(2) x_max(2) ]);
    view(2)
    hold off

    subplot(2,2,3)
    title('histogram of dists.');
    hold on
    bar(binloc,counts);
    hold off
    
    
    plot_title = ['histogram of KNN-Dist,K=',num2str(num_knn)];
    subplot(2,2,4)
    title(plot_title);
    hold on
    bar(binlocKNN,countsKNN);
    hold off

    h = findobj(gca,'Type','patch');
    set(h,'FaceColor','k','EdgeColor','k')
    colormap(map)
end
