#include "mex.h"
//#include "distances.h"
#include <math.h>

void mexFunction(int nlhs, mxArray *plhs[],
		 int nrhs, const mxArray *prhs[]) {
  // Test number of parameters.
  if (nrhs != 2 || nlhs != 2) {
    mexWarnMsgTxt("Usage: [KNN, KNN_DIST] = getKNN(Points,K)");
    return;
  }

  int i,j,m;
  int SPARSE=0,check,counter;
  double dist,diff;
  
  // Parse parameters
  int K = (int) (mxGetScalar(prhs[1])+0.1);
  int dim = (int)mxGetM(prhs[0]);
  int num = (int)mxGetN(prhs[0]);
  double* points = mxGetPr(prhs[0]);
  long index,index1,index2;
  double dummy;

  // Allocate memory for output
  //plhs[0] =  mxCreateNumericMatrix(K, num, mxINT32_CLASS, mxREAL);
  plhs[0] =  mxCreateDoubleMatrix(K, num, mxREAL);
  double* KNN = mxGetPr(plhs[0]);
  plhs[1] =  mxCreateDoubleMatrix(K, num, mxREAL);
  double* KNNDist = mxGetPr(plhs[1]);

  int* max_min_nr  =new int[num];
  int* zaehler= new int[num];

  index=0;
  for(i=0;i<num; i++)
   { max_min_nr[i]=i*K; zaehler[i]=0; }

  //mexPrintf("dim:%i, num: %i\n",dim,num);
  // now the real k nearest neighbor search
  for(i=0;i<num;i++)
  {
    //if(i % 100 ==0)
	//{ mexPrintf("Done: %i\n",i);}
    // now search through the other points to determine the k nearest neigbhors
    for(j=0; j<num ; j++)
    {
	  if(j !=i)
	  {
        // compute the squared distance to this point
        dist=0;
        index1=i*dim;
        index2=j*dim;
        for(m=0; m<dim; m++)
        {
          diff = (points[index1]-points[index2]) ;
          dist += diff*diff;
          ++index1; ++index2;
        } 
        //mexPrintf("i: %i, j: %i, dist: %f\n",i,j,dist);

        if(zaehler[i]<K)
        {
        KNNDist[max_min_nr[i]] =dist;
        KNN[max_min_nr[i]] =j;
        max_min_nr[i]++;
        zaehler[i]++;
		//mexPrintf("%i %i, dist: %f, maxmin: %i, zaehler: %i\n",i,j,dist,max_min_nr[i],zaehler[i]);
        if(zaehler[i]==K)
        {
          max_min_nr[i]=i*K;
		  dummy=KNNDist[max_min_nr[i]];
          index=(i+1)*K;
		  //mexPrintf("%i, maxmin: %i, dummy: %f\n",index,max_min_nr[i],dummy);
          for(m=i*K;m < i*K+K; m++)
          {
			//mexPrintf("%f\n",KNNDist[m] );
            if(KNNDist[m] > dummy)
             {  max_min_nr[i]=m; dummy=KNNDist[m];}
          }
        }
        }
      else if(dist < KNNDist[max_min_nr[i]])
      {
        KNNDist[max_min_nr[i]] =dist;       // put the distance into the bin where the maximal distance used to be
        KNN[max_min_nr[i]] =j;     // put the number into the bin where the number with the maximal distance ....

        index=(i+1)*K;
		dummy=KNNDist[max_min_nr[i]];
        for(m=i*K;m < index; m++)
        {
           if(KNNDist[m] > dummy)
            {  max_min_nr[i]=m; dummy=KNNDist[m];}
        }
      }
	  }
    }
  }
  for(i=0;i<K*num;i++)           // until now we computed the squared distance
   { KNN[i]++; KNNDist[i]=sqrt(KNNDist[i]); }

  delete max_min_nr; delete zaehler;
}